c$$$    SURFER fluid interface simulation program
c$$$    Copyright (C) 2001 Stephane Zaleski and others
c$$$
c$$$    This library is free software; you can redistribute it and/or
c$$$    modify it under the terms of the GNU Lesser General Public
c$$$    License as published by the Free Software Foundation; either
c$$$    version 2.1 of the License, or (at your option) any later version.
c$$$
c$$$    This library is distributed in the hope that it will be useful,
c$$$    but WITHOUT ANY WARRANTY; without even the implied warranty of
c$$$    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
c$$$    Lesser General Public License for more details.
c$$$
c$$$    You should have received a copy of the GNU Lesser General Public
c$$$    License along with this library; if not, write to the Free Software
c$$$    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
c$$$
c$$$    Stephane Zaleski zaleski@lmm.jussieu.fr
c
      PROGRAM Drop
      include 'undefined.h'
      INTEGER tmax,tmovie,tprint,tsave
      INTEGER t,i
      INCLUDE 'size.h'
      INCLUDE 'global.f'
      INCLUDE 'pointers.f'
      write(6,*) 
     c "$Id: Drop.f,v 1.1 2002/02/07 16:55:49 zaleski Exp $"
      call initlog()
      CALL machineid()
      open(unit=11)
      write(11,*) 
     c "$Id: Drop.f,v 1.1 2002/02/07 16:55:49 zaleski Exp $"
 
c$$$      call read_stdin()  in principle useless
      call initialize(tmax,tprint)
      call closelog()

      i = ifetch("tsave",tsave)
      tmovie = tprint
      call flush(6)
      do t=0,tmax
         if(mod(t,tsave).eq.0) then
            call save(u,v,z(icc(ng)),z(iei(ng)),
     $                z(ires(ng)),tau,nx,ny)
            call flush(6)
         endif
         call timestep(t,tprint)
      enddo
c
c  Close movie file
c
      close(12)
c
c  Close spurious currents file
c
      close(67) 
      STOP
      end

      SUBROUTINE initialize(tmax,tprint)
      include 'undefined.h'
      INTEGER tmax,tprint,restart,i
      INCLUDE 'size.h'
      INCLUDE 'global.f'
      INCLUDE 'pointers.f'
      call readglob(tmax,tprint)
      restart=0
      i=ifetch("restart",restart)
      write(6,*) "restart=",restart
c
      call printhist(tprint)
      call initpressure(nx,ny)

      if(restart.eq.0) then
c
c Include here relevant initialisation module
c
c It should be called ini"something". 
c

         call ini1disk(u,v,z(icc(ng)),z(iu(ng)),xvel,yvel,tau,nx,ny)

c$$$        write(6,*) "x symmetry check for disk initialisation c"
c$$$        call  chkx(cc,nx,ny,0,1)
c$$$        write(6,*) "y symmetry check for disk initialisation c"
c$$$        call  chky(cc,nx,ny,0,1)
         call addlayer(u,v,z(icc(ng)),z(iu(ng)),xvel,tau,nx,ny)
      else
         call iniget(u,v,z(icc(ng)),z(iu(ng)),tau,nx,ny)
      endif

      call makebccf(z(icc(ng)),nx,ny)
      call makebcf(u,v,nx,ny)
c
c Used in rhouv version
c
c      call acfromcc(z(icc(ng)),z(ia(ng)),z(ic(ng)),
c     %              z(iei(ng)),z(ires(ng)),nx,ny)
c      call rhouv(rhou,rhov,u,v,z(ia(ng)),z(ic(ng)),rhogas,nx,ny)
c      call makebcf(rhou,rhov,nx,ny)

      return
      end
